module BoundedInt exposing (..)

type alias BoundedInt =
    { value : Int
    , min : Int
    , max : Int
    }

new : Int -> Int -> Int -> BoundedInt
new value min max =
    if value < min 
    || value > max
    || min > max
    then 
        { value = 0 
        , min = 0
        , max = 0
        }
    else
        { value = value 
        , min = min
        , max = max
        }

change : BoundedInt -> Int -> BoundedInt
change boundedInt value =
    if value < boundedInt.min
    || value > boundedInt.max
    then
        boundedInt
    else
        { boundedInt | value = value }